Index: TWiki/UI/Statistics.pm
===================================================================
--- TWiki/UI/Statistics.pm	(revision 13172)
+++ TWiki/UI/Statistics.pm	(working copy)
@@ -49,7 +49,7 @@
 
 =pod
 
----++ StaticMethod statistics( $session )
+---++ StaticMethod statistics( )
 
 =statistics= command handler.
 This method is designed to be
@@ -62,26 +62,24 @@
 =cut
 
 sub statistics {
-    my $session = shift;
+    my $webName = $TWiki::SESSION->{webName};
 
-    my $webName = $session->{webName};
-
     my $tmp = '';
     # web to redirect to after finishing
     my $destWeb = $TWiki::cfg{UsersWebName};
-    my $logDate = $session->{cgiQuery}->param( 'logdate' ) || '';
+    my $logDate = $TWiki::SESSION->{cgiQuery}->param( 'logdate' ) || '';
     $logDate =~ s/[^0-9]//g;  # remove all non numerals
-    $debug = $session->{cgiQuery}->param( 'debug' );
+    $debug = $TWiki::SESSION->{cgiQuery}->param( 'debug' );
 
-    unless( $session->inContext( 'command_line' )) {
+    unless( $TWiki::SESSION->inContext( 'command_line' )) {
         # running from CGI
-        $session->writePageHeader();
+        $TWiki::SESSION->writePageHeader();
         print CGI::start_html(-title=>'TWiki: Create Usage Statistics');
     }
     # Initial messages
-    _printMsg( $session, 'TWiki: Create Usage Statistics' );
-    _printMsg( $session, '!Do not interrupt this script!' );
-    _printMsg( $session, '(Please wait until page download has finished)' );
+    _printMsg( 'TWiki: Create Usage Statistics' );
+    _printMsg( '!Do not interrupt this script!' );
+    _printMsg( '(Please wait until page download has finished)' );
 
     unless( $logDate ) {
         $logDate =
@@ -94,18 +92,18 @@
         $logYear = $1;
         $logMonth = $TWiki::Time::ISOMONTH[ ( $2 % 12 ) - 1 ];
     } else {
-        _printMsg( $session, "!Error in date $logDate - must be YYYYMM" );
+        _printMsg( "!Error in date $logDate - must be YYYYMM" );
         return;
     }
 
     my $logMonthYear = "$logMonth $logYear";
-    _printMsg( $session, "* Statistics for $logMonthYear" );
+    _printMsg( "* Statistics for $logMonthYear" );
 
     my $logFile = $TWiki::cfg{LogFileName};
     $logFile =~ s/%DATE%/$logDate/g;
 
     unless( -e $logFile ) {
-        _printMsg( $session, "!Log file $logFile does not exist; aborting" );
+        _printMsg(  "!Log file $logFile does not exist; aborting" );
         return;
     }
 
@@ -134,21 +132,21 @@
     # Do a single data collection pass on the temporary copy of logfile,
     # then process each web once.
     my ($viewRef, $contribRef, $statViewsRef, $statSavesRef, $statUploadsRef) =
-      _collectLogData( $session, $TMPFILE, $logMonthYear );
+      _collectLogData( $TMPFILE, $logMonthYear );
 
     my @weblist;
-    my $webSet = TWiki::Sandbox::untaintUnchecked($session->{cgiQuery}->param( 'webs' )) || $session->{requestedWebName};
+    my $webSet = TWiki::Sandbox::untaintUnchecked($TWiki::SESSION->{cgiQuery}->param( 'webs' )) || $TWiki::SESSION->{requestedWebName};
     if( $webSet) {
         # do specific webs
         push( @weblist, split( /,\s*/, $webSet ));
     } else {
         # otherwise do all user webs:
-        @weblist = $session->{store}->getListOfWebs( 'user' );
+        @weblist = $TWiki::STORE->getListOfWebs( 'user' );
     }
     my $firstTime = 1;
     foreach my $web ( @weblist ) {
         try {
-            $destWeb = _processWeb( $session,
+            $destWeb = _processWeb(
                                 $web,
                                 $logMonthYear,
                                 $viewRef,
@@ -158,7 +156,7 @@
                                 $statUploadsRef,
                                 $firstTime );
         } catch TWiki::AccessControlException with  {
-            _printMsg( $session, '  - ERROR: no permission to CHANGE statistics topic in '.$web);
+            _printMsg( '  - ERROR: no permission to CHANGE statistics topic in '.$web);
         }
         $firstTime = 0;
     }
@@ -167,15 +165,15 @@
     unlink $tmpFilename;# FIXME: works on Windows???  Unlink before
     # usage to ensure deleted on crash?
 
-    if( !$session->inContext( 'command_line' ) ) {
+    if( !$TWiki::SESSION->inContext( 'command_line' ) ) {
         $tmp = $TWiki::cfg{Stats}{TopicName};
-        my $url = $session->getScriptUrl( 0, 'view', $destWeb, $tmp );
-        _printMsg( $session, '* Go back to '
+        my $url = $TWiki::SESSION->getScriptUrl( 0, 'view', $destWeb, $tmp );
+        _printMsg( '* Go back to '
                    . CGI::a( { href => $url,
                                rel => 'nofollow' }, $tmp) );
     }
-    _printMsg( $session, 'End creating usage statistics' );
-    print CGI::end_html() unless( $session->inContext( 'command_line' ) );
+    _printMsg( 'End creating usage statistics' );
+    print CGI::end_html() unless( $TWiki::SESSION->inContext( 'command_line' ) );
 }
 
 # Debug only
@@ -210,7 +208,7 @@
 #   $contrib{$web}{"Main.".$WikiName} == number of saves/uploads, by user
 
 sub _collectLogData {
-    my( $session, $TMPFILE, $theLogMonthYear ) = @_;
+    my( $TMPFILE, $theLogMonthYear ) = @_;
 
     # Log file format:
     # | date | user | op | web.topic | notes | ip |
@@ -243,7 +241,7 @@
             $logFileUserName = shift @fields;
         }
         
-        my $userObj = $session->{users}->findUser($logFileUserName);
+        my $userObj = $TWiki::USERS->findUser($logFileUserName);
         
         my( $opName, $webTopic, $notes, $ip ) = @fields;
 
@@ -300,7 +298,7 @@
                 }
             }
         } else {
-            $session->writeDebug('WebStatistics: Bad logfile line '.$line);
+            $TWiki::SESSION->writeDebug('WebStatistics: Bad logfile line '.$line);
         }
     }
 
@@ -308,16 +306,16 @@
 }
 
 sub _processWeb {
-    my( $session, $web, $theLogMonthYear, $viewRef, $contribRef,
+    my( $web, $theLogMonthYear, $viewRef, $contribRef,
         $statViewsRef, $statSavesRef, $statUploadsRef, $isFirstTime ) = @_;
 
-    my( $topic, $user ) = ( $session->{topicName}, $session->{user} );
+    my( $topic, $user ) = ( $TWiki::SESSION->{topicName}, $TWiki::SESSION->{user} );
 
     if( $isFirstTime ) {
-        _printMsg( $session, '* Executed by '.$user->wikiName() );
+        _printMsg( '* Executed by '.$user->wikiName() );
     }
 
-    _printMsg( $session, "* Reporting on TWiki.$web web" );
+    _printMsg( "* Reporting on TWiki.$web web" );
 
     # Handle null values, print summary message to browser/stdout
     my $statViews = $statViewsRef->{$web};
@@ -326,7 +324,7 @@
     $statViews ||= 0;
     $statSaves ||= 0;
     $statUploads ||= 0;
-    _printMsg( $session, "  - view: $statViews, save: $statSaves, upload: $statUploads" );
+    _printMsg( "  - view: $statViews, save: $statSaves, upload: $statUploads" );
 
     
     # Get the top N views and contribs in this web
@@ -339,11 +337,11 @@
     if( @topViews ) {
         $statTopViews = join( CGI::br(), @topViews );
         $topViews[0] =~ s/[\[\]]*//g;
-        _printMsg( $session, '  - top view: '.$topViews[0] );
+        _printMsg( '  - top view: '.$topViews[0] );
     }
     if( @topContribs ) {
         $statTopContributors = join( CGI::br(), @topContribs );
-        _printMsg( $session, '  - top contributor: '.$topContribs[0] );
+        _printMsg( '  - top contributor: '.$topContribs[0] );
     }
 
     # Update the WebStatistics topic
@@ -352,9 +350,9 @@
     my $statsTopic = $TWiki::cfg{Stats}{TopicName};
     # DEBUG
     # $statsTopic = 'TestStatistics';		# Create this by hand
-    if( $session->{store}->topicExists( $web, $statsTopic ) ) {
+    if( $TWiki::STORE->topicExists( $web, $statsTopic ) ) {
         my( $meta, $text ) =
-          $session->{store}->readTopic( undef, $web, $statsTopic, undef );
+          $TWiki::STORE->readTopic( undef, $web, $statsTopic, undef );
         my @lines = split( /\r?\n/, $text );
         my $statLine;
         my $idxStat = -1;
@@ -393,15 +391,15 @@
         }
         $text = join( "\n", @lines );
         $text .= "\n";
-        $session->{store}->saveTopic( $user, $web, $statsTopic,
+        $TWiki::STORE->saveTopic( $user, $web, $statsTopic,
                                       $text, $meta,
                                       { minor => 1,
                                         dontlog => 1 } );
 
-        _printMsg( $session, "  - Topic $statsTopic updated" );
+        _printMsg( "  - Topic $statsTopic updated" );
 
     } else {
-        _printMsg( $session, "! Warning: No updates done, topic $web.$statsTopic does not exist" );
+        _printMsg( "! Warning: No updates done, topic $web.$statsTopic does not exist" );
     }
 
     return $web;
@@ -460,9 +458,9 @@
 }
 
 sub _printMsg {
-    my( $session, $msg ) = @_;
+    my( $msg ) = @_;
 
-    if( $session->inContext('command_line') ) {
+    if( $TWiki::SESSION->inContext('command_line') ) {
         $msg =~ s/&nbsp;/ /go;
     } else {
         if( $msg =~ s/^\!// ) {
Index: TWiki/UI/View.pm
===================================================================
--- TWiki/UI/View.pm	(revision 13172)
+++ TWiki/UI/View.pm	(working copy)
@@ -43,7 +43,7 @@
 
 =pod
 
----++ StaticMethod view( $session )
+---++ StaticMethod view()
 
 =view= command handler.
 This method is designed to be
@@ -61,12 +61,10 @@
 =cut
 
 sub view {
-    my $session = shift;
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $webName = $TWiki::SESSION->{webName};
+    my $topicName = $TWiki::SESSION->{topicName};
 
-    my $query = $session->{cgiQuery};
-    my $webName = $session->{webName};
-    my $topicName = $session->{topicName};
-
     my $raw = $query->param( 'raw' ) || '';
     my $contentType = $query->param( 'contenttype' );
 
@@ -74,13 +72,13 @@
     my $logEntry = '';
     my $revdate = '';
     my $revuser = '';
-    my $store = $session->{store};
+    my $store = $TWiki::STORE;
     # is this view indexable by search engines? Default yes.
     my $indexableView = 1;
 
-    TWiki::UI::checkWebExists( $session, $webName, $topicName, 'view' );
+    TWiki::UI::checkWebExists( $webName, $topicName, 'view' );
 
-    my $skin = $session->getSkin();
+    my $skin = $TWiki::SESSION->getSkin();
 
     my $rev = $store->cleanUpRevID( $query->param( 'rev' ));
 
@@ -93,9 +91,9 @@
     my( $meta, $text );
     if( $topicExists ) {
         ( $currMeta, $currText ) = $store->readTopic
-          ( $session->{user}, $webName, $topicName, undef );
-        TWiki::UI::checkAccess( $session, $webName, $topicName,
-                                'VIEW', $session->{user}, $currText );
+          ( $TWiki::SESSION->{user}, $webName, $topicName, undef );
+        TWiki::UI::checkAccess( $webName, $topicName,
+                                'VIEW', $TWiki::SESSION->{user}, $currText );
         ( $revdate, $revuser, $showRev ) = $currMeta->getRevisionInfo();
         $revdate = TWiki::Time::formatTime( $revdate );
 
@@ -105,7 +103,7 @@
 
         if( $rev < $showRev ) {
             ( $meta, $text ) = $store->readTopic
-              ( $session->{user}, $webName, $topicName, $rev );
+              ( $TWiki::SESSION->{user}, $webName, $topicName, $rev );
 
             ( $revdate, $revuser ) = $meta->getRevisionInfo();
             $revdate = TWiki::Time::formatTime( $revdate );
@@ -133,14 +131,14 @@
 
     } else { # Topic does not exist yet
         $indexableView = 0;
-        $session->enterContext( 'new_topic' );
+        $TWiki::SESSION->enterContext( 'new_topic' );
         $rev = 1;
         if( TWiki::isValidTopicName( $topicName )) {
             ( $currMeta, $currText ) =
-              TWiki::UI::readTemplateTopic( $session, 'WebTopicViewTemplate' );
+              TWiki::UI::readTemplateTopic( 'WebTopicViewTemplate' );
         } else {
             ( $currMeta, $currText ) =
-              TWiki::UI::readTemplateTopic( $session, 'WebTopicNonWikiTemplate' );
+              TWiki::UI::readTemplateTopic( 'WebTopicNonWikiTemplate' );
         }
         ( $text, $meta ) = ( $currText, $currMeta );
         $logEntry .= ' (not exist)';
@@ -155,34 +153,34 @@
     }
 
     if( $TWiki::cfg{Log}{view} ) {
-        $session->writeLog( 'view', $webName.'.'.$topicName, $logEntry );
+        $TWiki::SESSION->writeLog( 'view', $webName.'.'.$topicName, $logEntry );
     }
 
     my( $mirrorSiteName, $mirrorViewURL, $mirrorLink, $mirrorNote ) =
-      $session->readOnlyMirrorWeb( $webName );
+      $TWiki::SESSION->readOnlyMirrorWeb( $webName );
 
     # Note; must enter all contexts before the template is read, as
     # TMPL:P is expanded on the fly in the template reader. :-(
     my( $revTitle, $revArg ) = ( '', '' );
     if( $mirrorSiteName ) {
-        $session->enterContext( 'inactive' );
+        $TWiki::SESSION->enterContext( 'inactive' );
         unless( $topicExists ) {
             $text = '';
         }
     } elsif( $rev < $showRev ) {
-        $session->enterContext( 'inactive' );
+        $TWiki::SESSION->enterContext( 'inactive' );
         # disable edit of previous revisions
         $revTitle = '(r'.$rev.')';
         $revArg = '&rev='.$rev;
     }
 
     my $template = $query->param( 'template' ) ||
-      $session->{prefs}->getPreferencesValue( 'VIEW_TEMPLATE' ) ||
+      $TWiki::PREFS->getPreferencesValue( 'VIEW_TEMPLATE' ) ||
         'view';
 
-    my $tmpl = $session->{templates}->readTemplate( $template, $skin );
+    my $tmpl = $TWiki::TEMPLATES->readTemplate( $template, $skin );
     if( !$tmpl && $template ne 'view' ) {
-        $tmpl = $session->{templates}->readTemplate( 'view', $skin );
+        $tmpl = $TWiki::TEMPLATES->readTemplate( 'view', $skin );
     }
 
     if( !$tmpl ) {
@@ -216,15 +214,17 @@
         if( $doingRev == $rev) {
             $revs .= 'r'.$rev;
         } else {
-            $revs .= CGI::a({
-                             href=>$session->getScriptUrl( 0,
-                                                           'view',
-                                                           $webName,
-                                                           $topicName,
-                                                           rev => $doingRev ),
-                             rel => 'nofollow'
-                            },
-                            "r$doingRev" );
+            $revs .= CGI::a(
+                {
+                    href=>$TWiki::SESSION->getScriptUrl(
+                        0,
+                        'view',
+                        $webName,
+                        $topicName,
+                        rev => $doingRev ),
+                    rel => 'nofollow'
+                   },
+                "r$doingRev" );
         }
         if ( $doingRev - $rev >= $TWiki::cfg{NumberOfRevisions} ) {
             # we started too far away, need to jump closer to $rev
@@ -236,7 +236,7 @@
         }
         if( $revsToShow ) {
             $revs .= '&nbsp;' . CGI::a
-              ( { href=>$session->getScriptUrl(
+              ( { href=>$TWiki::SESSION->getScriptUrl(
                   0, 'rdiff', $webName, $topicName,
                   rev1 => $doingRev,
                   rev2 => $doingRev-1 ),
@@ -246,9 +246,9 @@
         $doingRev--;
     }
 
-    my $ri = $session->{renderer}->renderRevisionInfo( $webName,
-                                                       $topicName,
-                                                       $meta );
+    my $ri = $TWiki::RENDER->renderRevisionInfo( $webName,
+                                                 $topicName,
+                                                 $meta );
     $tmpl =~ s/%REVINFO%/$ri/go;
     $tmpl =~ s/%REVISIONS%/$revs/go;
 
@@ -316,15 +316,15 @@
     } else {
         $contentType = 'text/html'
     }
-    $session->{SESSION_TAGS}{MAXREV} = $showRev;
-    $session->{SESSION_TAGS}{CURRREV} = $rev;
+    $TWiki::SESSION->{SESSION_TAGS}{MAXREV} = $showRev;
+    $TWiki::SESSION->{SESSION_TAGS}{CURRREV} = $rev;
 
     # Set page generation mode to RSS if using an RSS skin
-    $session->enterContext( 'rss' ) if $skin =~ /\brss/;
+    $TWiki::SESSION->enterContext( 'rss' ) if $skin =~ /\brss/;
 
     # Set the meta-object that contains the rendering info
     # SMELL: hack to get around not having a proper topic object model
-    $session->enterContext( 'can_render_meta', $meta );
+    $TWiki::SESSION->enterContext( 'can_render_meta', $meta );
 
     my $page;
     # Legacy: If the _only_ skin is 'text' it is used like this:
@@ -337,43 +337,44 @@
         # use raw text
         $page = $text;
     } else {
-        my @args = ( $session, $webName, $topicName, $meta, $minimalist );
+        my @args = ( $webName, $topicName, $meta, $minimalist );
 
-        $session->enterContext( 'header_text' );
+        $TWiki::SESSION->enterContext( 'header_text' );
         $page = _prepare($start, @args);
-        $session->leaveContext( 'header_text' );
+        $TWiki::SESSION->leaveContext( 'header_text' );
 
         if( $raw ) {
-	    if ($text) {
-	      my $p = $session->{prefs};
-	      $page .=
-		CGI::textarea( -readonly => 'readonly',
-			       -rows => $p->getPreferencesValue('EDITBOXHEIGHT'),
-			       -cols => $p->getPreferencesValue('EDITBOXWIDTH'),
-			       -style => $p->getPreferencesValue('EDITBOXSTYLE'),
-			       -default => $text
-			     );
-	    }
+            if ($text) {
+                my $p = $TWiki::PREFS;
+                $page .=
+                  CGI::textarea(
+                      -readonly => 'readonly',
+                      -rows => $p->getPreferencesValue('EDITBOXHEIGHT'),
+                      -cols => $p->getPreferencesValue('EDITBOXWIDTH'),
+                      -style => $p->getPreferencesValue('EDITBOXSTYLE'),
+                      -default => $text
+                     );
+            }
         } else {
-            $session->enterContext( 'body_text' );
+            $TWiki::SESSION->enterContext( 'body_text' );
             $page .= _prepare($text, @args);
-            $session->leaveContext( 'body_text' );
+            $TWiki::SESSION->leaveContext( 'body_text' );
         }
 
-        $session->enterContext( 'footer_text' );
+        $TWiki::SESSION->enterContext( 'footer_text' );
         $page .= _prepare($end, @args);
-        $session->leaveContext( 'footer_text' );
+        $TWiki::SESSION->leaveContext( 'footer_text' );
     }
     # Output has to be done in one go, because if we generate the header and
     # then redirect because of some later constraint, some browsers fall over
-    $session->writeCompletePage( $page, 'view', $contentType )
+    $TWiki::SESSION->writeCompletePage( $page, 'view', $contentType )
 }
 
 sub _prepare {
-    my( $text, $session, $webName, $topicName, $meta, $minimalist) = @_;
+    my( $text, $webName, $topicName, $meta, $minimalist) = @_;
 
-    $text = $session->handleCommonTags( $text, $webName, $topicName, $meta );
-    $text = $session->{renderer}->getRenderedVersion( $text, $webName, $topicName );
+    $text = $TWiki::SESSION->handleCommonTags( $text, $webName, $topicName, $meta );
+    $text = $TWiki::RENDER->getRenderedVersion( $text, $webName, $topicName );
     $text =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;
 
     if( $minimalist ) {
@@ -387,7 +388,7 @@
 
 =pod
 
----++ StaticMethod viewfile( $session, $web, $topic, $query )
+---++ StaticMethod viewfile( $web, $topic, $query )
 
 =viewfile= command handler.
 This method is designed to be
@@ -400,17 +401,15 @@
 =cut
 
 sub viewfile {
-    my $session = shift;
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $webName = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
 
-    my $query = $session->{cgiQuery};
-    my $webName = $session->{webName};
-    my $topic = $session->{topicName};
-
     my $fileName = $query->param( 'filename' );
     $fileName = TWiki::Sandbox::sanitizeAttachmentName( $fileName );
 
-    my $rev = $session->{store}->cleanUpRevID( $query->param( 'rev' ) );
-    unless( $fileName && $session->{store}->attachmentExists(
+    my $rev = $TWiki::STORE->cleanUpRevID( $query->param( 'rev' ) );
+    unless( $fileName && $TWiki::STORE->attachmentExists(
         $webName, $topic, $fileName )) {
         throw TWiki::OopsException( 'attention',
                                     def => 'no_such_attachment',
@@ -418,10 +417,10 @@
                                     topic => $topic,
                                     params => [ 'viewfile', $fileName||'?' ] );
     }
-    my $fileContent = $session->{store}->readAttachment(
-        $session->{user}, $webName, $topic, $fileName, $rev );
+    my $fileContent = $TWiki::STORE->readAttachment(
+        $TWiki::SESSION->{user}, $webName, $topic, $fileName, $rev );
 
-    my $type = _suffixToMimeType( $session, $fileName );
+    my $type = _suffixToMimeType( $fileName );
     my $length =  length( $fileContent );
     my $dispo = 'inline;filename='.$fileName;
 
@@ -435,7 +434,7 @@
 }
 
 sub _suffixToMimeType {
-    my( $session, $theFilename ) = @_;
+    my( $theFilename ) = @_;
 
     my $mimeType = 'text/plain';
     if( $theFilename =~ /\.([^.]+)$/ ) {
